﻿using System;
using System.Collections.ObjectModel;
using System.ServiceModel;
using WpfSmartConnect.Properties;

namespace WpfSmartConnect
{
    class 着信記録一覧
    {
        // バインディングの指定先プロパティ
        public ObservableCollection<着信記録> d_着信記録 { get; }
        public ObservableCollection<着信記録> d_着信記録_更新済み { get; }

        private ServiceReference2.SCS_ServiceClient _client;

        // コンストラクタ(データ入力)
        public 着信記録一覧(int top = 0, long k_id = 0, string [] from = null)
        {
            try
            {
                var settings = Settings.Default;

                //SCSへ接続する
                _client = new ServiceReference2.SCS_ServiceClient();
                _client.Endpoint.Address = new EndpointAddress("http://" + settings.SvrAddr + ":55963/CTI_SmartConnectService/SCS_Service/");

                var scs = _client.着信記録(top, true, k_id, from, null);
                d_着信記録 = Newtonsoft.Json.JsonConvert.DeserializeObject<ObservableCollection<着信記録>>(scs);

                //更新済み用
                d_着信記録_更新済み = new ObservableCollection<着信記録>();
            }
            catch (FaultException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信でエラーが発生しました。", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (TimeoutException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信がタイムアウトしました。\r\n\r\n以下の確認をしてください。\r\n 1. サーバーアドレスが間違っていないか？\r\n 2. サーバーに光CTIスマートコネクトサービスがインストール済みか？", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (CommunicationException)
            {
                Logs_MessageBox.Show("光CTIスマートコネクトサービスとの通信が確立出来ません。\r\n\r\n以下の確認をしてください。\r\n 1. サーバーアドレスが間違っていないか？\r\n 2. サーバーに光CTIスマートコネクトサービスがインストール済みか？", "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
            catch (Exception ex)
            {
                Logs_MessageBox.Show(ex.Message, "エラー", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Error);
                if (_client != null)
                {
                    _client.Abort();
                }
            }
        }
    }
}
